"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const QuoteNode_1 = require("./QuoteNode");
const HelpfeelNode_1 = require("./HelpfeelNode");
const StrongImageNode_1 = require("./StrongImageNode");
const StrongIconNode_1 = require("./StrongIconNode");
const StrongNode_1 = require("./StrongNode");
const FormulaNode_1 = require("./FormulaNode");
const DecorationNode_1 = require("./DecorationNode");
const CodeNode_1 = require("./CodeNode");
const BlankNode_1 = require("./BlankNode");
const UrlNode_1 = require("./UrlNode");
const GoogleMapNode_1 = require("./GoogleMapNode");
const InternalLinkNode_1 = require("./InternalLinkNode");
const IconNode_1 = require("./IconNode");
const HashTagNode_1 = require("./HashTagNode");
const PlainNode_1 = require("./PlainNode");
const FalsyEliminator = (text, _opt, next) => {
    if (!text)
        return [];
    return next();
};
const combineNodeParsers = (...parsers) => {
    return (text = '', opt = { nested: false, quoted: false }) => (parsers.slice().reverse().reduce((acc, parser) => () => parser(text, opt, acc), () => PlainNode_1.PlainNodeParser(text))());
};
exports.convertToLineNodes = combineNodeParsers(FalsyEliminator, QuoteNode_1.QuoteNodeParser, HelpfeelNode_1.HelpfeelNodeParser, CodeNode_1.CodeNodeParser, FormulaNode_1.FormulaNodeParser, BlankNode_1.BlankNodeParser, StrongImageNode_1.StrongImageNodeParser, StrongIconNode_1.StrongIconNodeParser, StrongNode_1.StrongNodeParser, DecorationNode_1.DecorationNodeParser, UrlNode_1.UrlNodeParser, IconNode_1.IconNodeParser, GoogleMapNode_1.GoogleMapNodeParser, InternalLinkNode_1.InternalLinkNodeParser, HashTagNode_1.HashTagNodeParser);
//# sourceMappingURL=index.js.map